{ procTPU - podpora "procesu" v Turbo Pascalu }
{ 14. 10. 1998 luki@kiv.zcu.cz }

{ Tento modul vzniknul upravou predchoziho modulu - misto explicitniho
  prepinani procedur je prepinani provadeno automaticky pri kazdem patem
  preruseni od casovace. 

                      "Handling interrupts is simple." (G. Pajari)
          "Interrupts are an unpleasant fact of life." (A. Tanenbaum) }

{ Each "process" is implemented as a thread - it has its own
  private stack and code, but the address space is shared. All the
  threads are scheduled in a simple round-robin manner. }

unit procTPU;

interface

Uses Crt, Dos;

Procedure InitSystem;              { Musite zavolat drive nez cokoli jineho }
Procedure TaskInit(Task:pointer);  { Inicializace ulohy. }
Procedure RunSystem;               { Spusteni uloh }
Procedure Quit;                    { Navrat do hlavniho programu }


implementation

const
     CitMax = 5;               { Pocet preruseni nez dojde k preplanovani }

Type stavy = (RDY, BLK);       { Stavy procesu: RDY=pripraven, BLK=blokovan. }

     CB = Record
              STAV : stavy;    { Stav procesu }
              SS   : Word;
              SP   : Word;
          end;

Var  Process      : Integer;              { Cislo aktivniho procesu. }
     Tab          : Array[ 0..9 ] of CB;  { Tabulka procesu. }
     XSP,XSS,POMS,POMP : Word;
     TMP          : Pointer; { TaskInit }
     a            : char;    { SwitchContext }
     MaxProcess   : integer;
     QuitFlag     : boolean;
     SavedInt     : pointer; { Puvodni adresa obsluzneho podpr. preruseni }
     OldIsr       : procedure absolute SavedInt;
     Citac        : integer;


procedure InitSystem;
begin
   For Process:=0 to 9 do Tab[Process].Stav:=BLK;
   Process:=0;
   QuitFlag:=false;
end;


Procedure Scheduler; { Planovac - najde dalsi proces, ktery je RDY }
begin                { a naplanuje ho. }
   repeat
      Inc(Process);
      if Process > MaxProcess then
         Process:=1;
   until Tab[Process].Stav = RDY
end;


Procedure SwitchContext; Interrupt; { Meni kontext procesu. }
begin
   asm
     pushf
   end;
   OldIsr;      { Zavolani stare obsluhy preruseni }

   if Citac=0 then
   begin
        Citac:=CitMax;  { Planovac se bude volat pouze kazde 5te preruseni }

        Tab[Process].SS:=SSeg;
        Tab[Process].SP:=SPtr;
        if QuitFlag then  { Koncime! }
        begin
             SetIntVec($8,SavedInt);
             Process:=0
        end
        else
             Scheduler;
        POMS:=Tab[Process].SS;
        POMP:=Tab[Process].SP;
        asm
           mov   ax,POMS
           mov   bx,POMP
           mov   ss,ax
           mov   sp,bx
        end;
   end
   else
       Dec(Citac)
end;


Procedure Quit; { Navrat do hlavniho programu. }
begin
     QuitFlag:=true;
end;


Procedure TaskInit; { Vytvoreni uzivatelskeho kontextu. }
begin
   inc(Process);
   Maxprocess:=Process;
   Tab[Process].Stav:=RDY;

   GetMem(TMP,$1000);
   asm
     mov  ax,word ptr ds:[tmp+2]
     mov  POMS,ax
   end;
   XSS:=SSeg;                     { Soucasne ukazatele na zasobnik }
   XSP:=SPtr;
   Tab[Process].SS:=POMS;        { Ukazatel na nove vytvoreny kontext }
   Tab[Process].SP:=$1000 - 24;  { Bottom of Stack - misto pro registry }
   asm                           { Vytvoreni noveho kontextu }
     mov   ax,POMS
     mov   bx,$1000
     cli
     mov   ss,ax
     mov   sp,bx                 { Nastaveni noveho zasobniku }
     sti
     pushf                       { Priznaky, abychom se mohli vratit RETI }
     push  es                    { Jedno slovo ze stareho stacku: }
     mov   es,XSS
     mov   ax,word ptr es:[bp+4]
     pop   es
     push  ax                    { ... ulozime }
     push  es                    { Druhe slovo ze stareho stacku: }
     mov   es,XSS
     mov   ax,word ptr es:[bp+6]
     pop   es
     push  ax                    { ... ulozime }
     push  ax                    { Vsechny registry na stack }
     push  bx
     push  cx
     push  dx
     push  si
     push  di
     push  ds
     push  es
     push  bp
     mov   ax,XSS                { Vratime ukazatel zasobniku zpatky }
     mov   bx,XSP
     cli
     mov   ss,ax
     mov   sp,bx
     sti
   end;
end;


procedure RunSystem;
begin
   Citac:=0;
   Process:=0;
   GetIntVec($8,SavedInt);
   SetIntVec($8,addr(SwitchContext));
   asm
      pushf
      call far[SwitchContext]
   end;
   SetIntVec($8,SavedInt);
end;

end.
